#include <windows.h>
#include <commctrl.h>
#include <cmath>
#include "resource.h"
#include <stdio.h>
#include <TCHAR.h>
#include <process.h>
#include <atlstr.h>
//#include "vs.h"
#include "./vst/vst.h"

#pragma once
#pragma comment (lib, "winmm.lib")
#pragma comment (lib, "ComCtl32.lib")

#define MYMSG_TRAY (WM_APP + 1)
#define ID_MYTRAY 101

#define EXP 1.0594630943592952645618252949461
#define NUM_BUFS 8

#define SARUTY_SAMPLE_RATE	44100
#define SARUTY_SAMPLE_BITS	16
#define SARUTY_TITLE		TEXT("++")

LRESULT CALLBACK DlgProc(HWND, UINT, WPARAM, LPARAM);
short RingBuffer(short in, int nChannel);
BOOL GetFilePath(HWND hWnd, LPCTSTR lpszTitle, LPTSTR lpszPath, int nMaxLen);

HINSTANCE hInst;
double dVolume;
double dFreqRatio;
BOOL g_fVstValid = FALSE;

#define SHOWCLIP
#define REDRAW_TIMER_ID 100
#define STOP_TIMER_ID	101

TCHAR szIniPath[512];
HANDLE hThread;
UINT uThreadId;
CRITICAL_SECTION lock;
volatile DWORD dwLastClip = 0xFFFFFFFF;
bool bCliped;
BOOL g_isStarted;
DWORD g_dwBufferSize = 0;
WAVEFORMATEX g_wfe;
HMENU hMenu, hSubMenu;
PBYTE pBufferIn[NUM_BUFS], pBufferOut[NUM_BUFS];
WAVEHDR whdrIn[NUM_BUFS], whdrOut[NUM_BUFS];
HWAVEIN hWaveIn;
HWAVEOUT hWaveOut;
NOTIFYICONDATA nid;
BOOL isInTray;
volatile BOOL isReset;
volatile int g_nFadeCount = 0;
volatile int g_nFadeStart = 0;

struct SETTINGS {
	TCHAR szInCapsPname[MAXPNAMELEN];
	TCHAR szOutCapsPname[MAXPNAMELEN];
	int nVolume;
	int nFreqRatio;
	TCHAR szBufferSize[8];
	TCHAR szVstPath[MAX_PATH+1];
}settings;

UINT WINAPI WorkerThreadProcIn(LPVOID pArguments);
void SaveSettings();
void LoadSettings();
void GetIniPath();
BOOL StartProcess(HWND hDlg);
void EndProcess(HWND hDlg);
void LoadVstPlugin(HWND hWnd);
void UnloadVstPlugin(HWND hWnd);
BOOL OnInitDialog(HWND hDlg);
BOOL OnCommand(HWND hDlg, UINT nCmdId);

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);
	hInst = hInstance;

	INITCOMMONCONTROLSEX ic;
	ic.dwSize = sizeof(INITCOMMONCONTROLSEX);
	ic.dwICC = ICC_BAR_CLASSES;
	InitCommonControlsEx(&ic);

	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), NULL, (DLGPROC)DlgProc);
	return 0;
}

LRESULT CALLBACK DlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
	case WM_INITDIALOG:
		{
			return OnInitDialog(hDlg);	
		}
	case WM_COMMAND:
		{
			return OnCommand(hDlg, LOWORD(wParam));
		}
	case WM_TIMER:
		{
			switch (wParam)
			{
#ifdef  SHOWCLIP
			case REDRAW_TIMER_ID:
				InvalidateRect(GetDlgItem(hDlg,IDC_STATIC_VOLUME), NULL, FALSE);
				break;
#endif//SHOWCLIP
			case STOP_TIMER_ID:
				EndProcess(hDlg);
				break;
			}
			break;
		}
#ifdef  SHOWCLIP
	case WM_CTLCOLORSTATIC:
		{
			HDC hdc = (HDC)wParam;
			if( GetDlgItem( hDlg, IDC_STATIC_VOLUME) == (HWND)lParam) {
				SetBkMode(hdc, TRANSPARENT);
				if((GetTickCount() - dwLastClip > 700) || isReset) {
					SetTextColor( hdc, RGB( 0, 0, 0)) ;
				} else {
					SetTextColor( hdc, RGB( 200, 0, 0)) ;
				}
				return (LRESULT)(HBRUSH)GetStockObject(NULL_BRUSH);
			}
			break;
		}
#endif//SHOWCLIP
#if FALSE
	case MM_WIM_DATA:
		{
			if(isReset){
				return TRUE;
			}
			static int curBuf = 0;
			int tmp;
			short *shSrc, *shDest;

			DWORD dwShortsRecorded = (((LPWAVEHDR)lParam)->dwBytesRecorded) >> 1;
			shSrc = (short*)(((LPWAVEHDR)lParam)->lpData);
			shDest = (short*)(pBufferOut[curBuf]);
			for(UINT i = 0; i < dwShortsRecorded; i++){
				shDest[i] = RingBuffer(shSrc[i], i % 2);
			}

			waveOutWrite(hWaveOut, &whdrOut[curBuf], sizeof(WAVEHDR));
			curBuf = (curBuf + 1) % NUM_BUFS;
			waveInAddBuffer(hWaveIn, (LPWAVEHDR)lParam, sizeof(WAVEHDR));

			return TRUE;
		}
#endif
	case WM_VSCROLL:
		{
			if((HWND)lParam == GetDlgItem(hDlg, IDC_SLIDER1)){
				int nPos = (int)SendDlgItemMessage(hDlg, IDC_SLIDER1, TBM_GETPOS, 0, 0);
				EnterCriticalSection(&lock);
				dVolume = pow(10.0, -nPos / 100.0);
				LeaveCriticalSection(&lock);
				TCHAR buf[16];
				_stprintf(buf, TEXT("%.1f"), dVolume);
				SetDlgItemText(hDlg, IDC_TXT_VOLVAL, buf);
				return TRUE;
			}else if((HWND)lParam == GetDlgItem(hDlg, IDC_SLIDER2)){
				int nPos = (int)SendDlgItemMessage(hDlg, IDC_SLIDER2, TBM_GETPOS, 0, 0);
				EnterCriticalSection(&lock);
				dFreqRatio = pow(EXP, -nPos * 12.0 / 200);
				LeaveCriticalSection(&lock);
				TCHAR buf[16];
				_stprintf(buf, TEXT("%+d"), -nPos);
				SetDlgItemText(hDlg, IDC_TXT_PITCHVAL, buf);
				return TRUE;
			}
			break;
		}
	case MYMSG_TRAY:
		{
			if(wParam == ID_MYTRAY) {
				if(lParam == WM_LBUTTONUP) {
					isInTray = FALSE;
					Shell_NotifyIcon(NIM_DELETE, &nid);
					ShowWindow(hDlg, SW_NORMAL);
					VST_EditShowWindow(SW_NORMAL);
					return TRUE;
				}else if(lParam == WM_RBUTTONUP) {
					POINT pt;
					GetCursorPos(&pt);
					SetForegroundWindow(hDlg);
					TrackPopupMenu(hSubMenu, TPM_BOTTOMALIGN, pt.x, pt.y, 0, hDlg, NULL);
					return TRUE;
				}
			}
			break;
		}
	case WM_SYSCOMMAND:
		{
			if(wParam == SC_MINIMIZE) {
				Shell_NotifyIcon(NIM_ADD, &nid);
				ShowWindow(hDlg, SW_HIDE);
				VST_EditShowWindow(SW_HIDE);
				isInTray = TRUE;
				return TRUE;
			}
			break;
		}
	case WM_CLOSE:
		{
			if(isInTray) {
				Shell_NotifyIcon(NIM_DELETE, &nid);
			}
			EndProcess(hDlg);
			UnloadVstPlugin(hDlg);
			GetDlgItemText(hDlg, IDC_EDIT1, settings.szBufferSize, 8);
			GetDlgItemText(hDlg, IDC_COMBO1, settings.szInCapsPname, MAXPNAMELEN);
			GetDlgItemText(hDlg, IDC_COMBO2, settings.szOutCapsPname, MAXPNAMELEN);
			settings.nVolume = (int)SendDlgItemMessage(hDlg, IDC_SLIDER1, TBM_GETPOS, 0, 0);
			settings.nFreqRatio = (int)SendDlgItemMessage(hDlg, IDC_SLIDER2, TBM_GETPOS, 0, 0);
			SaveSettings();
			DeleteCriticalSection(&lock);
			DestroyMenu(hMenu);
			EndDialog(hDlg, IDCANCEL);
			return TRUE;
		}
	}

	return FALSE;
}

BOOL OnInitDialog(HWND hDlg)
{
	SetWindowText(hDlg, SARUTY_TITLE);

	HICON hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON1));//
//	SetClassLon(hDlg, GCL_HICON, (LONG)hIcon);
	SendMessage(hDlg, WM_SETICON, ICON_BIG, (LPARAM)hIcon);
	GetIniPath();
	LoadSettings();
	InitializeCriticalSection(&lock);
	dVolume = 1.0;
	dFreqRatio = 1.0;

	// obt@TCYKl
	//SetDlgItemText(hDlg, IDC_EDIT1, TEXT("50"));

	SendDlgItemMessage(hDlg, IDC_RADIO1, BM_SETCHECK, BST_CHECKED, 0);

	UINT nNumDevs = waveInGetNumDevs();
	WAVEINCAPS wic;
	for(UINT i = 0; i < nNumDevs; i++){
		if(waveInGetDevCaps(i, &wic, sizeof(wic)) == MMSYSERR_NOERROR)
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)wic.szPname);
	}
	SendDlgItemMessage(hDlg, IDC_COMBO1, CB_SETCURSEL, 0, 0);
	nNumDevs = waveOutGetNumDevs();
	WAVEOUTCAPS woc;
	for(UINT i = 0; i < nNumDevs; i++){
		if(waveOutGetDevCaps(i, &woc, sizeof(woc)) == MMSYSERR_NOERROR)
			SendDlgItemMessage(hDlg, IDC_COMBO2, CB_ADDSTRING, 0, (LPARAM)woc.szPname);
	}
	SendDlgItemMessage(hDlg, IDC_COMBO2, CB_SETCURSEL, 0, 0);

	// XC_[̐ݒ
	SendDlgItemMessage(hDlg, IDC_SLIDER1, TBM_SETRANGE, TRUE, MAKELPARAM(-200, 0));
	SendDlgItemMessage(hDlg, IDC_SLIDER1, TBM_SETTICFREQ, 20, 0);
	SendDlgItemMessage(hDlg, IDC_SLIDER2, TBM_SETRANGE, TRUE, MAKELPARAM(-200, 200));
	SendDlgItemMessage(hDlg, IDC_SLIDER2, TBM_SETTICFREQ, 40, 0);

	//settings
	SendDlgItemMessage(hDlg, IDC_COMBO1, CB_SELECTSTRING, -1, (LPARAM)settings.szInCapsPname);
	SendDlgItemMessage(hDlg, IDC_COMBO2, CB_SELECTSTRING, -1, (LPARAM)settings.szOutCapsPname);
	SendDlgItemMessage(hDlg, IDC_SLIDER1, TBM_SETPOS, TRUE, settings.nVolume);
	SendMessage(hDlg, WM_VSCROLL, 0, (LPARAM)GetDlgItem(hDlg, IDC_SLIDER1));
	SendDlgItemMessage(hDlg, IDC_SLIDER2, TBM_SETPOS, TRUE, settings.nFreqRatio);
	SendMessage(hDlg, WM_VSCROLL, 0, (LPARAM)GetDlgItem(hDlg, IDC_SLIDER2));
	SetDlgItemText(hDlg, IDC_EDIT1, settings.szBufferSize);
		
	// j[nh̎擾
	hMenu = LoadMenu(hInst, MAKEINTRESOURCE(IDR_MENU1));
	hSubMenu = GetSubMenu(hMenu, 0);

	// EF[utH[}bg̎w
	// 16rbgXeI 44100Hz
	g_wfe.wFormatTag = WAVE_FORMAT_PCM;
	g_wfe.nChannels = 2;
	g_wfe.wBitsPerSample = SARUTY_SAMPLE_BITS;
	g_wfe.nSamplesPerSec = SARUTY_SAMPLE_RATE;
	g_wfe.nBlockAlign = g_wfe.nChannels * g_wfe.wBitsPerSample/8;
	g_wfe.nAvgBytesPerSec = g_wfe.nBlockAlign * g_wfe.nSamplesPerSec;
	// ܂ŃEF[utH[}bg

	// NOTIFYICONDATA̐ݒ
	nid.cbSize = sizeof(NOTIFYICONDATA);
	nid.hIcon = hIcon;
	nid.hWnd = hDlg;
	nid.uCallbackMessage = MYMSG_TRAY;
	nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	nid.uID = ID_MYTRAY;
	lstrcpy(nid.szTip , SARUTY_TITLE);
	// ܂NOTIFYICONDATA
	//dVolume = 1.0;
	//dFreqRatio = 1.0;
	isInTray = FALSE;
	g_isStarted = FALSE;
	isReset = FALSE;

	return TRUE;
}

BOOL OnCommand(HWND hDlg, UINT nCmdId)
{
	switch (nCmdId)
	{
	case IDM_START:
		{
			return StartProcess(hDlg);
		}
	case IDM_STOP:
		{
			EnableWindow(GetDlgItem(hDlg, IDM_STOP), FALSE);
			g_nFadeStart = - SARUTY_SAMPLE_RATE / 10;	// tF[hAEg 0.1b
			g_nFadeCount =   SARUTY_SAMPLE_RATE / 10;
			SetTimer(hDlg, STOP_TIMER_ID, 200, NULL);
			return TRUE;
		}
	case IDC_RADIO1:
		{
			dFreqRatio = 1.0;
			SendDlgItemMessage(hDlg, IDC_SLIDER2, TBM_SETPOS, (WPARAM)TRUE, 0);
			SetDlgItemText(hDlg, IDC_TXT_PITCHVAL, TEXT("+0"));
			return TRUE;
		}
	case IDC_RADIO2:
		{
			dFreqRatio = 2.0;
			SendDlgItemMessage(hDlg, IDC_SLIDER2, TBM_SETPOS, (WPARAM)TRUE, -200);
			SetDlgItemText(hDlg, IDC_TXT_PITCHVAL, TEXT("+200"));
			return TRUE;
		}
	case IDC_RADIO3:
		{
			dFreqRatio = 0.5;
			SendDlgItemMessage(hDlg, IDC_SLIDER2, TBM_SETPOS, (WPARAM)TRUE, 200);
			SetDlgItemText(hDlg, IDC_TXT_PITCHVAL, TEXT("-200"));
			return TRUE;
		}
	case IDM_EXIT:
		{
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			return TRUE;
		}
	case IDC_CMD_VSTOPEN:
		if (g_fVstValid) {
			UnloadVstPlugin(hDlg);
		} else {
			if (GetFilePath(hDlg, TEXT("VST vOCJ"), settings.szVstPath, MAX_PATH)) {
				LoadVstPlugin(hDlg);
			}
			return TRUE;
		}
	case IDC_CMD_VSTCONF:
		if (g_fVstValid) {
			VST_OpenEdit(hDlg);
			return TRUE;
		}
	}

	return FALSE;
}

BOOL StartProcess(HWND hDlg)
{
	hThread = (HANDLE)_beginthreadex(NULL, 0, &WorkerThreadProcIn, NULL, 0, &uThreadId);//
	if(!hThread) return FALSE;
#ifdef SHOWCLIP
	SetTimer(hDlg, REDRAW_TIMER_ID, 200, NULL);
#endif
	isReset = FALSE;
	g_nFadeStart = SARUTY_SAMPLE_RATE; // tF[hCPb
	g_nFadeCount = 0;
	UINT uSrcDevID, uDestDevID;
	TCHAR szBuf[256];
	uSrcDevID = (UINT)SendDlgItemMessage(hDlg, IDC_COMBO1, CB_GETCURSEL, 0, 0);
	uDestDevID = (UINT)SendDlgItemMessage(hDlg, IDC_COMBO2, CB_GETCURSEL, 0, 0);
	GetDlgItemText(hDlg, IDC_EDIT1, szBuf, sizeof(szBuf) - 1);
	if(_ttoi(szBuf) < 10 || _ttoi(szBuf) > 10000) 
		return FALSE;
	g_dwBufferSize = (DWORD)((_ttoi(szBuf) * g_wfe.nAvgBytesPerSec) / 1000.0);
	g_dwBufferSize += (g_wfe.nBlockAlign - (g_dwBufferSize % g_wfe.nBlockAlign));
	//waveInOpen(&hWaveIn, uSrcDevID, &g_wfe, (DWORD)hDlg, 0, CALLBACK_WINDOW);
	//waveOutOpen(&hWaveOut, uDestDevID, &g_wfe, (DWORD)hDlg, 0, CALLBACK_WINDOW);
	waveInOpen(&hWaveIn, uSrcDevID, &g_wfe, (DWORD)uThreadId, 0, CALLBACK_THREAD);
	waveOutOpen(&hWaveOut, uDestDevID, &g_wfe, NULL, 0, CALLBACK_NULL);
	for(int i = 0; i < NUM_BUFS; i++){
		pBufferIn[i] = (PBYTE)calloc(g_dwBufferSize, 1);
		whdrIn[i].lpData = (LPSTR)pBufferIn[i];
		whdrIn[i].dwBufferLength = g_dwBufferSize;
		whdrIn[i].dwFlags = 0;
		waveInPrepareHeader(hWaveIn, &whdrIn[i], sizeof(WAVEHDR));
		waveInAddBuffer(hWaveIn, &whdrIn[i], sizeof(WAVEHDR));

		pBufferOut[i] = (PBYTE)calloc(g_dwBufferSize, 1);
		whdrOut[i].lpData = (LPSTR)pBufferOut[i];
		whdrOut[i].dwBufferLength = g_dwBufferSize;
		whdrOut[i].dwFlags = WHDR_BEGINLOOP | WHDR_ENDLOOP;
		whdrOut[i].dwLoops = 1;
		waveOutPrepareHeader(hWaveOut, &whdrOut[i], sizeof(WAVEHDR));
	}
	VST_SetMaxSampleCount(g_dwBufferSize / g_wfe.nChannels / (g_wfe.wBitsPerSample / 8));
	waveInStart(hWaveIn);
	EnableWindow(GetDlgItem(hDlg, IDC_COMBO1), FALSE);
	EnableWindow(GetDlgItem(hDlg, IDC_COMBO2), FALSE);
	EnableWindow(GetDlgItem(hDlg, IDM_START), FALSE);
	EnableWindow(GetDlgItem(hDlg, IDM_STOP), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT1), FALSE);
	EnableMenuItem(hSubMenu, IDM_START, MF_BYCOMMAND | MF_GRAYED);
	EnableMenuItem(hSubMenu, IDM_STOP, MF_BYCOMMAND | MF_ENABLED);
	g_isStarted = TRUE;

	return TRUE;
}

void EndProcess(HWND hDlg)
{
	if (!g_isStarted) {
		return;
	}

	KillTimer(hDlg, STOP_TIMER_ID);

	isReset = TRUE;
	PostThreadMessage(uThreadId, WM_QUIT, 0, 0);//
	WaitForSingleObject(hThread, INFINITE);
	CloseHandle(hThread);

	waveInReset(hWaveIn);
	waveOutReset(hWaveOut);

#ifdef SHOWCLIP
	KillTimer(hDlg, REDRAW_TIMER_ID);
	InvalidateRect(GetDlgItem(hDlg,IDC_STATIC_VOLUME), NULL, FALSE);
#endif

	for(int i = 0; i < NUM_BUFS; i++){
		waveInUnprepareHeader(hWaveIn, &whdrIn[i], sizeof(WAVEHDR));
		waveOutUnprepareHeader(hWaveOut, &whdrOut[i], sizeof(WAVEHDR));
		free(pBufferIn[i]);
		free(pBufferOut[i]);
	}

	waveInClose(hWaveIn);
	waveOutClose(hWaveOut);

	EnableWindow(GetDlgItem(hDlg, IDC_COMBO1), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_COMBO2), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDM_START), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDM_STOP), FALSE);
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT1), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CMD_VSTOPEN), TRUE);
	EnableMenuItem(hSubMenu, IDM_START, MF_BYCOMMAND | MF_ENABLED);
	EnableMenuItem(hSubMenu, IDM_STOP, MF_BYCOMMAND | MF_GRAYED);
	g_isStarted = FALSE;
}

#define RING_SIZE 882
#define X_SIZE 32

short RingBuffer(short in, int nChannel)
{
	static short buffer[2][RING_SIZE] = {{0}};
	static int writePos[2] = {0};
	static double readPos[2] = {0};
	static short xFadeBuf[2][X_SIZE * 2] = {{0}};
	static int xFadePos[2] = {0};
	static int xFrag[2] = {0};
	int ret;
	int tmpCur, tmpNext;
	int xPosTmp;

	buffer[nChannel][writePos[nChannel]] = in;
	tmpCur = (int)(readPos[nChannel]);
	tmpNext = tmpCur + 1;
	if(tmpNext >= RING_SIZE) tmpNext -= RING_SIZE;
	double dNul;
	double t = modf(readPos[nChannel], &dNul);
	ret = (int)(((double)buffer[nChannel][tmpCur] * (1.0 - t) + (double)buffer[nChannel][tmpNext] * t) * dVolume);
#ifdef SHOWCLIP
	if(ret > 32767 || ret < -32768) bCliped = true;
#endif
	ret = min(ret, 32767);
	ret = max(ret, -32768);

	double dif1, dif2;
	dif1 = writePos[nChannel] - readPos[nChannel];
	writePos[nChannel]++;
	readPos[nChannel] += dFreqRatio;
	dif2 = writePos[nChannel] - readPos[nChannel];
	if((dif1 * dif2) < 0) xFrag[nChannel] = X_SIZE * 2;
	if(writePos[nChannel] >= RING_SIZE) writePos[nChannel] -= RING_SIZE;
	if(readPos[nChannel] >= RING_SIZE) readPos[nChannel] -= RING_SIZE;

	xFadeBuf[nChannel][xFadePos[nChannel]] = ret;
	xPosTmp = xFadePos[nChannel] + X_SIZE;
	if(xPosTmp >= X_SIZE * 2) xPosTmp -= (X_SIZE * 2);
	if(xFrag[nChannel] > 0){
		ret = (int)(((double)xFadeBuf[nChannel][xPosTmp] * (double)abs(X_SIZE - xFrag[nChannel]) / (double)X_SIZE) +
			((double)xFadeBuf[nChannel][xFadePos[nChannel]] * (1.0 - ((double)abs(X_SIZE - xFrag[nChannel]) / (double)X_SIZE))));
		xFrag[nChannel]--;
	}else{
		ret = xFadeBuf[nChannel][xPosTmp];
	}
	xFadePos[nChannel]++;
	if(xFadePos[nChannel] >= X_SIZE * 2) xFadePos[nChannel] -= (X_SIZE * 2);

	return (short)ret;
}

UINT WINAPI WorkerThreadProcIn (void* pArguments)
{
	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL);
	MSG msg;

	while (GetMessage(&msg, NULL, 0, 0) > 0)
	{
		switch (msg.message)
		{
//		case MM_WIM_OPEN:
//			OutputDebugString(TEXT("MM_WIM_OPEN"));
//			break;
		case MM_WIM_DATA:
			{
				if (isReset) {
					break;
				}
				static int curBuf = 0;
//					int tmp;
				short *shSrc, *shDest;

				DWORD dwShortsRecorded = (((LPWAVEHDR)msg.lParam)->dwBytesRecorded) >> 1;
				shSrc = (short*)(((LPWAVEHDR)msg.lParam)->lpData);
				shDest = (short*)(pBufferOut[curBuf]);
				bCliped=false;		//

				EnterCriticalSection(&lock);			// --> Enter

				if (g_fVstValid)
				{
					VST_Process(shSrc, shDest, dwShortsRecorded / 2);
				}
				else
				{
					for(UINT i = 0; i < dwShortsRecorded; i++)
					{
						shDest[i] = RingBuffer(shSrc[i], i % 2);
					}
				}
					
				LeaveCriticalSection(&lock);			// <-- Leave

				// tF[hAEg
				if (g_nFadeStart < 0)
				{
					if (0 < g_nFadeCount)
					{
						for (UINT i = 0; i < dwShortsRecorded; i += 2)
						{
							float f = (float)g_nFadeCount / (float)(-g_nFadeStart);

							shDest[i+0] = (short)(shDest[i+0] * f);
							shDest[i+1] = (short)(shDest[i+1] * f);

							g_nFadeCount--;
						}
					}
					else
					{
						memset(shDest, 0, dwShortsRecorded * 2);
					}
				}
				// tF[hC
				else if (g_nFadeStart > 0)
				{
					if (g_nFadeCount < g_nFadeStart)
					{
						for (UINT i = 0; i < dwShortsRecorded; i += 2)
						{
							float f = (float)g_nFadeCount / (float)(g_nFadeStart);

							shDest[i+0] = (short)(shDest[i+0] * f);
							shDest[i+1] = (short)(shDest[i+1] * f);

							g_nFadeCount++;
						}
					}
				}

#ifdef SHOWCLIP
				if(bCliped) dwLastClip = GetTickCount();//
#endif
				waveOutWrite(hWaveOut, &whdrOut[curBuf], sizeof(WAVEHDR));
				curBuf = (curBuf + 1) % NUM_BUFS;
				waveInAddBuffer(hWaveIn, (LPWAVEHDR)msg.lParam, sizeof(WAVEHDR));
				break;
			}
		default:
			break;
		//case MM_WIM_CLOSE:
		//	OutputDebugString(TEXT("MM_WIM_CLOSE"));
		//	break;
		}
	}

	_endthreadex(0);
	return 0;
}
void GetIniPath(){
	TCHAR drive[_MAX_DRIVE];
	TCHAR dir[_MAX_DIR];
	TCHAR exepath[_MAX_PATH];
	GetModuleFileName(NULL, exepath, _MAX_PATH);
	_tsplitpath(exepath, drive, dir, NULL, NULL);
	_tmakepath(szIniPath, drive, dir, TEXT("SaRUty"), TEXT("ini"));
}
#define GetSettingString(lpKeyName,lpDefault,lpReturnedString,nSize) GetPrivateProfileString(TEXT("Settings"),lpKeyName,lpDefault,lpReturnedString,nSize,szIniPath)
void LoadSettings(){
	GetSettingString(TEXT("BufferSize"), TEXT("50"), settings.szBufferSize, 8);
	GetSettingString(TEXT("WaveInCapsName"), TEXT(""), settings.szInCapsPname, MAXPNAMELEN);
	GetSettingString(TEXT("WaveOutCapsName"), TEXT(""), settings.szOutCapsPname, MAXPNAMELEN);
	GetSettingString(TEXT("VstPath"), TEXT(""), settings.szVstPath, MAX_PATH);
	TCHAR num[8];
	GetSettingString(TEXT("Volume"), TEXT("0"), num, 8);
	settings.nVolume = _ttoi(num);
	GetSettingString(TEXT("FreqRatio"), TEXT("0"), num, 8); 
	settings.nFreqRatio = _ttoi(num);
}
#define WriteSettingString(lpKeyName, lpString) WritePrivateProfileString(TEXT("Settings"), lpKeyName, lpString, szIniPath)
void SaveSettings(){
	WriteSettingString(TEXT("BufferSize"), settings.szBufferSize);
	WriteSettingString(TEXT("WaveInCapsName"), settings.szInCapsPname);
	WriteSettingString(TEXT("WaveOutCapsName"), settings.szOutCapsPname);
	WriteSettingString(TEXT("VstPath"), settings.szVstPath);
	TCHAR num[8];
	_itot(settings.nVolume, num, 10);
	WriteSettingString(TEXT("Volume"), num);
	_itot(settings.nFreqRatio, num, 10);
	WriteSettingString(TEXT("FreqRatio"), num);
}

BOOL GetFilePath(HWND hWnd, LPCTSTR lpszTitle, LPTSTR lpszPath, int nMaxLen)
{
	OPENFILENAME ofn;
	ZeroMemory(&ofn, sizeof(OPENFILENAME));

	ofn.lStructSize		= sizeof(OPENFILENAME);
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= TEXT("VST Plugins (*.dll)\0*.dll\0ׂẴt@C (*.*)\0*.*\0\0");
	ofn.lpstrFile		= lpszPath;
	ofn.nMaxFile		= nMaxLen;
	ofn.lpstrDefExt		= TEXT("dll");
	ofn.lpstrTitle		= lpszTitle;
	ofn.Flags			= OFN_FILEMUSTEXIST | OFN_NONETWORKBUTTON | OFN_HIDEREADONLY;

	return GetOpenFileName(&ofn);
}

void SetVstState(HWND hDlg, BOOL fEnable)
{
	g_fVstValid = fEnable;
	SetDlgItemText(hDlg, IDC_CMD_VSTOPEN, fEnable ? TEXT("VSTJ") : TEXT("VSTǍ"));
	EnableWindow(GetDlgItem(hDlg, IDC_CMD_VSTCONF),	 fEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_SLIDER1),		!fEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_SLIDER2),		!fEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_RADIO1),		!fEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_RADIO2),		!fEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_RADIO3),		!fEnable);

}

void LoadVstPlugin(HWND hDlg)
{
	EnterCriticalSection(&lock);		// --> Enter

	VST_Unload();

	if (VST_Load(settings.szVstPath, SARUTY_SAMPLE_RATE))
	{
		if (g_isStarted)
		{
			VST_SetMaxSampleCount(g_dwBufferSize / g_wfe.nChannels / (g_wfe.wBitsPerSample / 8));
		}

		LeaveCriticalSection(&lock);	// <-- Leave
		VST_OpenEdit(hDlg);
		SetVstState(hDlg, TRUE);
	}
	else
	{
		LeaveCriticalSection(&lock);	// <-- Leave
		SetVstState(hDlg, FALSE);
		MessageBox(hDlg, TEXT("VSTvOC̃I[vɎs܂B"), SARUTY_TITLE, MB_ICONSTOP);
	}		
}

void UnloadVstPlugin(HWND hDlg)
{
	EnterCriticalSection(&lock);	// --> Enter
	VST_Unload();
	LeaveCriticalSection(&lock);	// <-- Leave
	SetVstState(hDlg, FALSE);
}